package com.supwisdom.dlpay.system.dao.impl;

import com.supwisdom.dlpay.framework.domain.TOperator;
import com.supwisdom.dlpay.system.dao.OperatorDao;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.TypedQuery;
import java.util.ArrayList;
import java.util.List;

@Repository
public class OperatorDaoImpl implements OperatorDao {

    @PersistenceContext
    EntityManager entityManager;

    @Transactional
    @Override
    public List<String> findOperatorsByFopercode(String operid) {
        try{
            String sql = "select bean from TOperator bean where bean.status='0' and bean.father.opercode =?1 ";
            TypedQuery<TOperator> query = entityManager.createQuery(sql, TOperator.class);
            query.setParameter(1, operid);
            List<TOperator> tOperators = new ArrayList<TOperator>();
            tOperators.addAll(query.getResultList());
            List<String> allopercode = new ArrayList<String>();
            if(tOperators != null && tOperators.size() > 0){
                for(TOperator grp:tOperators){
                    allopercode.add(grp.getOpercode());
                }
                boolean index = false;
                List<TOperator> lstsons = new ArrayList<TOperator>();
                List<TOperator> lstson = new ArrayList<TOperator>();
                lstson.addAll(tOperators);
                while(lstson != null && lstson.size() > 0){
                    if(index){
                        for(TOperator grp:lstson){
                            allopercode.add(grp.getOpercode());
                        }
                    }
                    index = true;
                    if(!lstsons.isEmpty()){
                        lstsons.clear();
                    }
                    for(TOperator grp:lstson){
                        String queryString = "select bean from TOperator bean where bean.father.opercode =?1";
                        query = entityManager.createQuery(queryString, TOperator.class);
                        query.setParameter(1, grp.getOpercode());
                        lstsons.addAll(query.getResultList());
                    }
                    if(!lstson.isEmpty()){
                        lstson.clear();
                    }
                    lstson.addAll(lstsons);
                }
            }
            allopercode.add(operid);

            return allopercode;
        }catch(Exception e){
            e.printStackTrace();
        }
        return null;
    }
}
